(define (scogen-manual)
  (let ((show (lambda a (for-each display a) (newline))))
    (show "")
    (show "MATHEMATISCHE FUNKTIONEN:")
    (show "   roundx..................(n nachkommastellen)")
    (show "   root....................(x n)")
    (show "   divs....................(n)")
    (show "")
    (show "LISTEN:")
    (show "listen erzeugen:")
    (show "   lini....................(start ende anzahl)")
    (show "   linitol.................(start ende anzahl toleranz)")
    (show "   expi....................(start ende anzahl kruemmung)")
    (show "   expitol.................(start ende anzahl kruemmung toleranz)")
    (show "   dist....................(start abstand anzahl)")
    (show "   fibonacci...............(start anzahl)")
    (show "   tend....................(unten-start unten-ende oben-start oben-ende anzahl)")
    (show "   rand....................(minimum maximum anzahl)")
    (show "listen veraendern:")
    (show "   sublist.................(liste start ende)")
    (show "   fromto..................(liste from to anzahl ueberlappung)")
    (show "   perm....................(liste laenge)")
    (show "   procmap.................(liste proc wert)")
    (show "   rep.....................(liste n)")
    (show "   rep-rand................(liste n-min n-max)")
    (show "   min.....................(liste)")
    (show "   max.....................(liste)")
    (show "   min+max.................(liste)")
    (show "   mean....................(liste)")
    (show "   sort....................(liste)")
    (show "   mix.....................(listenliste)")
    (show "")
    (show "TONHOEHENBERECHNUNG:")
    (show "   concert-pitch = 440")
    (show "   freq->pitch.............(frequenz)")
    (show "   harmonics...............(frequenz anzahl)")
    (show "")
    (show "SCORE-GENERATOR")
    (show "")
    (show "   scogen..................(dateipfad f-tables zeilenanzahl p-felder-liste)")))

;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

; MATHEMATISCHE FUNKTIONEN:


; rundet auf x nachkommastellen

(define (roundx n nachkommastellen)
  (/ (round (* n (expt 10 nachkommastellen))) (expt 10 nachkommastellen)))

; (roundx 1.1234 2)

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; zieht die x-te wurzel aus n

(define (root x n)
  (expt n (/ 1 x)))

; (root 3 27)

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; berechnet alle ganzzahligen teiler einer zahl n

(define (divs n)
  (letrec ((helper
	    (lambda (result zaehler)
	      (if (> zaehler (/ n 2))
		  (reverse (cons n result))
		  (if (integer? (/ n zaehler))
		      (helper (cons zaehler result) (+ zaehler 1))
		      (helper result (+ zaehler 1)))))))
	   (helper '() 1)))
  
; (divs 48777)

;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

; LISTEN


; lineare interpolation

(define (lini start ende anzahl)
  (cond ((<= anzahl 1)
	 (display "ERROR: anzahl zu klein - minimum ist 2")
	 (newline))
	(else (let ((abstand (/ (- ende start) (- anzahl 1))))
		(dist start abstand anzahl)))))

; (lini 0 100 11)

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; lineare interpolation mit toleranz

(define (linitol start ende anzahl toleranz)
  (let ((tol (/ toleranz 2)))
    (append (list start) (sublist (tend (- start tol) (- ende tol) (+ start tol) (+ ende tol) anzahl) 1 (- anzahl 2)) (list ende))))

; (linitol 1 11 5 3)

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; Exponentielle interpolation

(define (expi start ende anzahl kruemmung)
  (let ((expx (lambda (n) (roundx (expt n kruemmung) 3))))
    (cond ((< anzahl 2)
	   (display "ERROR: laenge zu kurz!")
	   (newline))
	  (else (append (list start) (sublist (map expx (dist (expt start (/ 1 kruemmung)) (/ (- (expt ende (/ 1 kruemmung)) (expt start (/ 1 kruemmung))) (- anzahl 1)) anzahl)) 1 (- anzahl 2)) (list ende ))))))

; (expi 3 9 10 3)

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; exponentielle interpolation mit toleranz

(define (expitol start ende anzahl kruemmung toleranz)
  (cond ((= toleranz 0)
	 (expi start ende anzahl kruemmung))
	(else
	 (let ((minus (lambda (n) (- n (/ toleranz 2)))))
	   (letrec ((helper (lambda (liste-alt liste-neu rd-liste)
			      (cond ((null? liste-alt)
				     (append (list start) liste-neu (list ende)))
				    (else (helper (cdr liste-alt) (cons (+ (car liste-alt) (car rd-liste)) liste-neu) (cdr rd-liste)))))))
	     (helper (reverse (map minus (sublist (expi start ende anzahl kruemmung) 1 (- anzahl 2)))) '() (rand 0 toleranz anzahl)))))))

; (expitol 0 9 4 2 10)

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; erstellt eine liste aus einer bestimmten anzahl an werten ab einem startwert und mit festen abstand

(define (dist start abstand anzahl)
  (letrec
      ((helper
	(lambda (n neuer-wert l)
	  (cond ((= n anzahl)
		 (reverse l))
		(else
		 (helper (+ n 1) (+ neuer-wert abstand) (cons (roundx neuer-wert 4.0) l)))))))
    (helper 0 start '())))

; (dist 1 3 5)

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; zeigt die fibonacci-zahlen in einer bestimmten anzahl von einem startwert an

(define (fibonacci start anzahl)
  (let ((show (lambda a (for-each display a))))
    (letrec ((helper (lambda (letzter vorletzter zaehler1 zaehler2 liste)
		       (cond ((or (< start 1)
				  (< anzahl 1))
			      (show "ERROR: zu kleiner Wert")
			      (newline))
			     ((> zaehler2 anzahl)
			      (reverse liste))
			     ((= start 1)
			      (cond ((= anzahl 1)
				     '(0))
				    ((= anzahl 2)
				     '(0 1))
				    (else (helper (+ vorletzter letzter) letzter zaehler1 (+ zaehler2 1) (cons vorletzter liste)))))
			     ((> start 1)
			      (cond ((= zaehler1 start)
				     (helper (+ vorletzter letzter) letzter zaehler1 (+ zaehler2 1) (cons letzter liste)))
				    (else (helper (+ vorletzter letzter) letzter (+ zaehler1 1) zaehler2 liste))))))))
      (helper 1 0 2 1 '()))))

; (fibonacci 1 8)     -> (0 1 1 2 3 5 8 13)

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; tendenzmaske

(define (tend unten-start unten-ende oben-start oben-ende anzahl)
  (let ((unten-liste (lini unten-start unten-ende anzahl))
	(oben-liste (lini oben-start oben-ende anzahl)))
    (letrec ((helper (lambda (zaehler u-ls o-ls liste)
		       (cond ((= zaehler anzahl)
			      (reverse liste))
			     (else (cond ((>= (car o-ls) (car u-ls))
					  (helper (+ zaehler 1) (cdr u-ls) (cdr o-ls) (cons (roundx (+ (abs (random (- (car o-ls) (car u-ls)))) (car u-ls)) 3) liste)))
					 (else (helper (+ zaehler 1) (cdr u-ls) (cdr o-ls) (cons (roundx (+ (abs (random (- (car u-ls) (car o-ls)))) (car o-ls)) 3) liste)))))))))
      (helper 0 unten-liste oben-liste '()))))

; (tend 5 5 10 0 40)

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; erzeugt eine liste mit einer bestimmten anzahl an beliebigen zahlen zwischen 2 werten

(define (rand minimum maximum anzahl)
  (letrec ((helper (lambda (n l)
		     (cond ((= n anzahl)
			    l)
			   (else (helper (+ n 1) (cons (roundx (+ minimum (/ (random (* (expt 10.0 3) (- maximum minimum))) (expt 10 3))) 3) l)))))))
    (helper 0 '())))

; (rand 0 20 5)

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; sublist

(define (sublist l start ende)
  (letrec ((helper (lambda (zaehler1 zaehler2 liste-alt liste-neu)
		     (cond ((= zaehler2 ende)
			    liste-neu)
			   ((= zaehler1 start)
			    (helper zaehler1 (+ zaehler2 1) (cdr liste-alt) (append liste-neu (list (car liste-alt)))))
			   (else (helper (+ zaehler1 1) zaehler2 (cdr liste-alt) liste-neu))))))
    (helper 0 (- start 1) l '())))

; (sublist '(a b c d e) 0 1)

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; from...to

(define (fromto liste from to anzahl ueberlappung)
  (letrec ((round+exact+abs (lambda (n)
			      (abs (inexact->exact (round n))))))
    (let ((l1 (map round+exact+abs (linitol from to anzahl ueberlappung))))
      (letrec ((helper (lambda (index-liste liste-neu)
			 (cond ((null? index-liste)
				liste-neu)
			       (else (cond ((> (car index-liste) to)
					    (helper (cdr index-liste) (append liste-neu (list (list-ref liste to)))))
					   ((< (car index-liste) from)
					    (helper (cdr index-liste) (append liste-neu (list (list-ref liste from)))))
					   (else (helper (cdr index-liste) (append liste-neu (list (list-ref liste (car index-liste))))))))))))
	(helper l1 '())))))

; (fromto '(a b c d e f g) 3 5 50 0)
; (fromto '(a b c d e f g) 3 5 50 5)

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; erzeugt eine liste mit einer bestimmten laenge, die den inhalt der gegebenen liste vertauscht
; es kann sein, dass nicht alle elemente der liste in der neuen liste enthalten sind!

(define (perm liste laenge)
  (letrec ((helper (lambda (n l)
		     (cond ((= n laenge)
			    l)
			   (else (helper (+ n 1) (cons (list-ref liste (random (length liste))) l)))))))
    (helper 0 '())))

; (perm '(1 2 3) 6)

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; addiert/subtrahiert/dividiert/multipliziert jedes element der liste mit einem bestimmten wert

(define (procmap liste proc wert)
  (let ((helper (lambda (n)
		  (proc n wert))))
    (map helper liste)))

; (procmap '(1 2 3) * 10.0)

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; wiederholt jedes element der liste n-mal

(define (rep liste n)
  (let ((same (lambda (elem n)
		(letrec ((helper (lambda (zaehler liste)
				   (cond ((= zaehler n)
					  liste)
					 (else (helper (+ zaehler 1) (cons elem liste)))))))
		  (helper 0 '())))))
  (letrec ((helper (lambda (l-alt l-neu)
		     (cond ((null? l-alt)
			    l-neu)
			   (else (helper (cdr l-alt) (append l-neu (same (car l-alt) n))))))))
    (helper liste '()))))

; (rep '(1 2 3) 3)

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; wiederholt jedes element der liste zwischen in der anzahl zwischen n-min und n-max

(define (rep-rand liste n-min n-max)
  (let ((same (lambda (elem n)
		(letrec ((helper (lambda (zaehler liste)
				   (cond ((= zaehler n)
					  liste)
					 (else (helper (+ zaehler 1) (cons elem liste)))))))
		  (helper 0 '())))))
  (letrec ((helper (lambda (l-alt l-neu)
		     (cond ((null? l-alt)
			    l-neu)
			   (else (helper (cdr l-alt) (append l-neu (same (car l-alt) (+ n-min (random (- n-max n-min)))))))))))
    (helper liste '()))))

; (rep-rand '(1 2 3) 2 4)

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; ermittelt den kleinsten wert einer liste

(define (min liste)
  (letrec ((helper (lambda (ls n)
		     (cond ((null? (cdr ls))
			    (if (<= (car ls) n)
				(cons (car ls) '())
				(cons n '())))
			   ((< (cadr ls) n)
			    (helper (cdr ls) (cadr ls)))
			   (else (helper (cdr ls) n))))))
    (helper liste (car liste))))

; (min '(5 1 4 0.1 7 9))

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; ermittelt den groessten wert einer liste

(define (max liste)
  (letrec ((helper (lambda (ls n)
		     (cond ((null? (cdr ls))
			    (if (>= (car ls) n)
				(cons (car ls) '())
				(cons n '())))
			   ((> (cadr ls) n)
			    (helper (cdr ls) (cadr ls)))
			   (else (helper (cdr ls) n))))))
    (helper liste (car liste))))

; (max '(5 1 4 0.1 7 9 8))

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; erzeugt eine liste mit dem minimum und dem maximum der liste

(define (min+max liste)
  (append (min liste) (max liste)))

; (min+max '(3 -5 0 12 -34))

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; ermittelt das arithmetische mittel einer liste

(define (mean liste)
  (list (exact->inexact (/ (apply + liste) (length liste)))))

; (mean '(0 1 2 10))

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; quicksort

(define (sort liste)
  (letrec ((helper (lambda (a b liste z)
		     (cond ((null? a) (cons liste (cons b (cons z '()))))
			   (else
			    (let ((x (car a)))
			      (if (<= x b) 
				  (helper (cdr a) b (cons x liste) z)
				  (helper (cdr a) b liste (cons x z))))))))
	   (partition (lambda (liste)
			(helper (cdr liste) (car liste) '() '()))))
    (cond ((null? liste) liste)
	  (else
	   (let ((l-part (partition liste)))
	     (append (sort (car l-part)) (cons (cadr l-part) (sort (caddr l-part)))))))))

; (sort (rand 0 10 100))

;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; mischt mehrere gleichlange listen in einer bergeordneten liste miteinander

(define (mix listen-liste) ; format: '((1 4 7) (2 5 8) (3 6 9))) -> (1 2 3 4 5 6 7 8 9)
  (let ((anzahl-listen (length listen-liste))
	(laenge-intern (length (car listen-liste)))
	(alte-liste (letrec ((helperx (lambda (l-alt l-neu)
					(cond ((null? l-alt)
					       l-neu)
					      (else (helperx (cdr l-alt) (append l-neu (car l-alt))))))))
		      (helperx listen-liste '())))
	(gleich-lang? (lambda (ls)
			(letrec ((helper (lambda (l)
					   (cond ((null? (cdr l))
						  #t)
						 ((= (length (car l)) (length (cadr l)))
						  (helper (cdr l)))
						 (else #f)))))
			  (helper listen-liste)))))
    (letrec ((helper (lambda (zaehler1 zaehler2 liste-neu)
		       (cond ((not (gleich-lang? listen-liste))
			      (display "ERROR: listen nicht gleich lang")
			      (newline))
			     ((= zaehler1 laenge-intern)
			      (reverse liste-neu))
			     ((= zaehler2 anzahl-listen)
			      (helper (+ zaehler1 1) 0 liste-neu))
			     (else (helper zaehler1 (+ zaehler2 1) (cons (list-ref alte-liste (+ zaehler1 (* zaehler2 laenge-intern))) liste-neu)))))))
      (helper 0 0 '()))))

; (mix '((1 4 7) (2 5 8) (3 6 9)))

;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

; FREQUENZEN


; gibt den ton mit centabweichung fr eine bestimme frequenz an

(define concert-pitch 440)

(define (freq->pitch frequenz)
  (let ((minimum (* (expt 2 (/ 5 24)) (/ concert-pitch (expt 2.0 9))))
	(maximum (* (expt 2 (/ 5 24)) (* concert-pitch (expt 2.0 6))))
	(1/2-ton (expt 2 (/ 1 12))))
    (letrec ((helper (lambda (oktave ton halbton)
		       (cond ((or (< frequenz minimum)
				  (> frequenz maximum))
			      (display "ERROR: frequenz zu hoch/tief")
			      (newline))
			     ((> ton 0.11)
			      (helper (+ oktave 1) 0.01 (* halbton 1/2-ton)))
			     ((> frequenz (* halbton 1/2-ton))
			      (helper oktave (+ ton 0.01) (* halbton 1/2-ton)))
			     (else (let ((centabweichung (- (* (/ 1200 (log 2)) (log (/ frequenz halbton))) 50)))
				     (cond ((<= centabweichung -100.0)
					    (cond ((= ton 0.00)
						   (cons (+ (- oktave 1) (- ton 0.01)) (cons (roundx (+ centabweichung 100) 2) '())))
						  (else (cons (+ oktave (- ton 0.01)) (cons (roundx (+ centabweichung 100) 2) '())))))
					   ((>= centabweichung 100.0)
					    (cond ((= ton 0.11)
						   (cons (+ (+ oktave 1) (+ ton 0.01)) (cons (roundx (- centabweichung 100) 2) '())))
						  (else (cons (+ oktave (+ ton 0.01)) (cons (roundx (- centabweichung 100) 2) '())))))
					   ((<= centabweichung -50)
					    (cond ((= ton 0.00)
						   (cons (+ (- oktave 1) (- ton 0.01)) (cons (roundx (+ centglweichung 100) 2) '())))
						  (else (cons (+ oktave (- ton 0.01)) (cons (roundx (+ centabweichung 100) 2) '())))))
					   ((>= centabweichung 50)
					    (cond ((= ton 0.11)
						   (cons (+ (+ oktave 1) (+ ton 0.01)) (cons (roundx (- centabweichung 100) 2) '())))
						  (else (cons (+ oktave (+ ton 0.01)) (cons (roundx (- centabweichung 100) 2) '())))))
					   (else (cons (+ oktave ton) (cons (roundx centabweichung 2) '()))))))))))
      (helper 0 0.00 minimum))))

; (freq->pitch 440) -> (8.09 0.0)
;- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
; berechnung einer bestimmten anzahl an obertoenen ueber einer frequenz

(define (harmonics frequenz anzahl)
  (dist frequenz frequenz anzahl))
		   
; (harmonics 65.4 8)

			    

;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&
;&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&&

; SCORE


; score-generator

(define (all-symbols? liste)
  (letrec ((helper (lambda (ls)
		     (cond ((null? ls)
			    #t)
			   ((not (symbol? (car ls)))
			    #f)
			   (else (helper (cdr ls)))))))
    (helper liste)))

(define (all-strings? liste)
  (letrec ((helper (lambda (ls)
		     (cond ((null? ls)
			    #t)
			   ((not (string? (car ls)))
			    #f)
			   (else (helper (cdr ls)))))))
    (helper liste)))

(define (all-numbers? liste)
  (letrec ((helper (lambda (ls)
		     (cond ((null? ls)
			    #t)
			   ((not (number? (car ls)))
			    #f)
			   (else (helper (cdr ls)))))))
    (helper liste)))

(define (same-type? liste)
  (cond ((or (equal? (all-symbols? liste) #t)
	     (equal? (all-strings? liste) #t)
	     (equal? (all-numbers? liste) #t))
	 #t)
	(else #f)))

(define (same-type-error? listenliste)
  (let ((show (lambda a (for-each display a) (newline))))
    (letrec ((helper (lambda (zaehler ls)
		       (cond ((null? ls)
			      #t)
			     ((not (list? (car ls)))
			      (show "ERROR: p"zaehler" ist keine liste"))
			     ((not (same-type? (car ls)))
			      (show "ERROR: fehler in p"zaehler))
			     (else (helper (+ zaehler 1) (cdr ls)))))))
      (helper 1 listenliste))))

(define parameters (lambda a
	    a))

(define lines 0)

(define (lines! a)
  (set! lines a))

(define tables (lambda a
		 a))

(define f# 'f)

(define (no-brackets liste)
  (let ((show (lambda a (for-each display a))))
    (cond ((null? liste)
	   (show ""))
	  (else (show (car liste) " ")
		(no-brackets (cdr liste))))))

(define ft (lambda (liste)
	     (let ((show (lambda a (for-each display a))))
	       (if (null? liste)
		   (show "")
		   (cond ((null? (cdr liste))
			  (cond ((not (list? (car liste)))
				 (show (car liste))
				 (newline)
				 (newline))
				(else (and (no-brackets (car liste))
					   (newline)
					   (newline)))))
			 ((list? (car liste))
			  (and (no-brackets (car liste))
			       (ft (cdr liste))))
			 ((equal? (cadr liste) f#)
			  (show (car liste) " ")
			  (newline)
			  (ft (cdr liste)))
			 (else (show (car liste) " ")
			       (ft (cdr liste))))))))

(define (scogen dateipfad f-tables zeilenanzahl p-felder-liste)
  (cond ((not (same-type-error? p-felder-liste))
	 #t)
	(else
	 (letrec ((make-score (lambda (anzahl-zeilen p-liste)
				(let  ((anzahl-p-felder (length p-liste))
				       (rotiere (lambda (l)
						  (letrec ((helper
							    (lambda (list index-zaehler)
							      (cond ((= index-zaehler (length l))
								     (reverse list))
								    (else (helper (cons (append (cdr (list-ref l index-zaehler)) (cons (car (list-ref l index-zaehler)) '())) list)
										  (+ index-zaehler 1)))))))
						    (helper '() 0)))))
				  (letrec ((helper
					    (lambda (zeilen-zaehler p-felder-zaehler ls)
					      (cond ((= zeilen-zaehler anzahl-zeilen)
						     (display ""))
						    ((= p-felder-zaehler 0)
						     (display "i")
						     (helper zeilen-zaehler (+ p-felder-zaehler 1) ls))
						    (else (cond ((= anzahl-p-felder (- p-felder-zaehler 1))
								 (newline)
								 (helper (+ zeilen-zaehler 1) 0 (rotiere ls)))
								(else (display " ")
								      (display (car (list-ref ls (- p-felder-zaehler 1))))
								      (helper zeilen-zaehler (+ p-felder-zaehler 1) ls))))))))
				    (helper 0 0 p-felder-liste))))))
	   (with-output-to-file dateipfad (lambda () (and (ft f-tables) (make-score lines p-felder-liste))))))))

; (score "/Users/daniel/Desktop/test.sco" 5
;       (list
;	'(1)
;	(linitol 100 10 5 10)
;	'("test.aif")))